MODULE mod_dzeta_mt

   USE mod_num_parms
   USE mod_int_imp
   
      IMPLICIT NONE

   
CONTAINS

   FUNCTION dzeta_mt_1(Mst1,Mst2,Mgl,Xt,muDec)

      IMPLICIT NONE

!!$  Passed variables

      REAL(kind=fp_kind), INTENT(IN) :: Mst1, Mst2, Mgl, Xt, muDec
      
!!$  function variable      
      REAL(kind=fp_kind):: dzeta_mt_1

!!$  Internal variables

      REAL(kind=fp_kind) :: Lst1, Lst2, Lgl
      REAL(kind=fp_kind) :: M2Dst1st2, M2Dglst1, M2Dglst2
      
      REAL(kind=fp_kind) ::dzeta_mt_1_Xt0, dzeta_mt_1_Xt1
      
      Lst1 = Log(muDec**2/Mst1**2)
      Lst2 = Log(muDec**2/Mst2**2)
      Lgl = Log(muDec**2/Mgl**2)


       
      M2Dst1st2 = Mst1**2-Mst2**2
      M2Dglst1 = Mgl**2-Mst1**2
      M2Dglst2 = Mgl**2-Mst2**2
      
!        WRITE(Write_unit,66) " Lst1   = ", Lst1
!        WRITE(Write_unit,66) " Lst2   = ", Lst2
!        WRITE(Write_unit,66) " Lgl   = ", Lgl
!        WRITE(Write_unit,66) " M2Dst1st2   = ", M2Dst1st2
!        WRITE(Write_unit,66) " M2Dglst1   = ", M2Dglst1
!        WRITE(Write_unit,66) " M2Dglst2   = ", M2Dglst2
      
      dzeta_mt_1_Xt0= (cf*( Lst1*(-0.5 + Mgl**4/(2.*M2Dglst1**2)) - Mst1**2/(2.*M2Dglst1)  &
                       & +Lgl*(-Mgl**4/(2.*M2Dglst1**2) - Mgl**4/(2.*M2Dglst2**2))  &
                       & +Lst2*(-0.5 + Mgl**4/(2.*M2Dglst2**2)) - Mgl**2/(2.*M2Dglst2)))
                       
      dzeta_mt_1_Xt1=(cf*((2.*Lgl*Mgl**2)/(M2Dglst1*M2Dglst2) &
                                 & +Lst2*((-2.*Mgl**2)/(M2Dglst1*M2Dglst2) + (2.*Mst1**2)/(M2Dglst1*M2Dst1st2)) &
                                 &-(2.*Lst1*Mst1**2)/(M2Dglst1*M2Dst1st2)))
                                 
!       WRITE(Write_unit,66) " dzeta_mt_1_Xt0   = ", dzeta_mt_1_Xt0
!       WRITE(Write_unit,66) " dzeta_mt_1_Xt1   = ", dzeta_mt_1_Xt1
      
      dzeta_mt_1 = (dzeta_mt_1_Xt0 + (Mgl*Xt)*dzeta_mt_1_Xt1)
      
! 66    FORMAT(A,E12.6)

   END FUNCTION dzeta_mt_1

   
   FUNCTION dzeta_mt_2(Mst1,Mst2,Msb1,Msb2,Msu1,Msu2,Msd1,Msd2,Mss1,Mss2,Msc1,Msc2,Mgl,Xt,muDec)

      IMPLICIT NONE

!!$  Passed variables

      REAL(kind=fp_kind), INTENT(IN) :: Mst1,Mst2,Msb1,Msb2,Msu1,Msu2,Msd1,Msd2,Mss1,Mss2,Msc1,Msc2,Mgl,Xt,muDec
      
!!$  function variable      
      REAL(kind=fp_kind):: dzeta_mt_2

!!$  Internal variables
      
      REAL(kind=fp_kind) :: dzeta_mt_2_sq(10), dzeta_mt_2_sqv, dzeta_mt_2_stv
      REAL(kind=fp_kind) :: Mx(10)
      INTEGER :: isum
      
      
!!$ contribution of "light" squarks      
      Mx(:)=(/Msu1,Msu2,Msd1,Msd2,Mss1,Mss2,Msc1,Msc2 ,Msb1, Msb2/)
      
      DO isum = 1,10
         dzeta_mt_2_sq(isum)=dzeta_mt_2_sqx(Mst1,Mst2,Mx(isum),Mgl,Xt,muDec)
      ENDDO
      dzeta_mt_2_sqv=SUM(dzeta_mt_2_sq)
!       WRITE(Write_unit,66) " dzeta_mt_2_sqv   = ", dzeta_mt_2_sqv
      
!!$ contribution of stop  squarks      
      dzeta_mt_2_stv = dzeta_mt_2_st(Mst1,Mst2,Mgl,Xt,muDec)

!       WRITE(Write_unit,66) " dzeta_mt_2_stv   = ", dzeta_mt_2_stv
!!$ total result       
      dzeta_mt_2 = (dzeta_mt_2_sqv + dzeta_mt_2_stv)
      
! 66    FORMAT(A,E12.6)

   END FUNCTION dzeta_mt_2
   
   
   FUNCTION dzeta_mt_2_sqx(Mst1,Mst2,Mx,Mgl,Xt,muDec)

      IMPLICIT NONE

!!$  Passed variables

      REAL(kind=fp_kind), INTENT(IN) :: Mst1,Mst2,Mx,Mgl,Xt,muDec
      
!!$  function variable      
      REAL(kind=fp_kind):: dzeta_mt_2_sqx

!!$  Internal variables

      REAL(kind=fp_kind) :: Lst1, Lst2, Lgl, Lx
      REAL(kind=fp_kind) :: M2Dst1st2, M2Dglst1, M2Dglst2
      REAL(kind=fp_kind) :: B0finglx      
      REAL(kind=fp_kind) :: T0finglx,T0finst1x,T0finst2x
      
      REAL(kind=fp_kind) ::dzeta_mt_2_sqx_Xt0, dzeta_mt_2_sqx_Xt1
      
      Lst1 = Log(muDec**2/Mst1**2)
      Lst2 = Log(muDec**2/Mst2**2)
      Lgl = Log(muDec**2/Mgl**2)
      Lx = Log(muDec**2/Mx**2)


       
      M2Dst1st2 = Mst1**2-Mst2**2
      M2Dglst1  = Mgl**2-Mst1**2
      M2Dglst2  = Mgl**2-Mst2**2
      
      
      B0finglx = B0fin(Mgl**2, Mx, 0.d0, muDec)
      
      T0finglx  = T0fin(Mgl, Mx)
      T0finst1x = T0fin(Mst1, Mx)
      T0finst2x = T0fin(Mst2, Mx)
      
!        WRITE(Write_unit,66) " Lst1   = ", Lst1
!        WRITE(Write_unit,66) " Lst2   = ", Lst2
!        WRITE(Write_unit,66) " Lgl   = ", Lgl
!        WRITE(Write_unit,66) " M2Dst1st2   = ", M2Dst1st2
!        WRITE(Write_unit,66) " M2Dglst1   = ", M2Dglst1
!        WRITE(Write_unit,66) " M2Dglst2   = ", M2Dglst2
      
      dzeta_mt_2_sqx_Xt0= (cf*tr*(Lx*(-11.d0/6.d0 + (-1.d0/(2.d0*M2Dglst1) - 1.d0/(2.d0*M2Dglst2) + &
&       Lst1*(1.d0/(2.d0*M2Dglst1) - Mgl**2/(2.d0*M2Dglst1**2)) + &
&       Lgl*((-3.d0*Mgl**2)/(2.d0*M2Dglst1**2) - (3.d0*Mgl**2)/(2.d0*M2Dglst2**2)) + &
&       Lst2*(1.d0/(2.d0*M2Dglst2) - Mgl**2/(2.d0*M2Dglst2**2)))*Mx**2) + &
&   Lx**2*(1.d0/2.d0 + (-1.d0/(4.d0*M2Dglst2) + Mgl**2/M2Dglst2**2 + (3.d0*Mgl**2 + Mst1**2)/&
&        (4.d0*M2Dglst1**2))*Mx**2) + Lst1*((2.d0*Mgl**4)/M2Dglst1**2 - &
&     (2.d0*Mgl**6)/M2Dglst1**3)*B0finglx + &
&   Lst2*((2.d0*Mgl**4)/M2Dglst2**2 - (2.d0*Mgl**6)/M2Dglst2**3)*&
&    B0finglx + Lgl*((-2.d0*Mgl**4)/M2Dglst2**2 + &
&     (2.d0*Mgl**6)/M2Dglst2**3 + (2.d0*Mgl**4*Mst1**2)/M2Dglst1**3)*&
&    B0finglx + (-(Mgl**2/M2Dglst2) + (2.d0*Mgl**4)/M2Dglst2**2 + &
&     (Mgl**2*(Mgl**2 + Mst1**2))/M2Dglst1**2)*B0finglx + &
&   ((-5.d0*Mgl**2)/(2.d0*M2Dglst2**2) + (2.d0*Mgl**4)/M2Dglst2**3 + &
&     (-Mgl**4 + 5.d0*Mgl**2*Mst1**2)/(2.d0*M2Dglst1**3))*T0finglx + &
&   (1.d0/(2.d0*M2Dglst1) + Mgl**2/(2.d0*M2Dglst1**2) - (2.d0*Mgl**4)/M2Dglst1**3)*&
&    T0finst1x + (1.d0/(2.d0*M2Dglst2) + Mgl**2/(2.d0*M2Dglst2**2) - &
&     (2.d0*Mgl**4)/M2Dglst2**3)*T0finst2x + &
&   Mx**2*(-3.d0/(2.d0*M2Dglst2) + (4.d0*Mgl**2)/M2Dglst2**2 + &
&     Lst1**2*(-1.d0/(4.d0*M2Dglst1) + (5.d0*Mgl**2)/(4.d0*M2Dglst1**2) - Mgl**4/M2Dglst1**3) + &
&     Lst2**2*(-1.d0/(4.d0*M2Dglst2) + (5.d0*Mgl**2)/(4.d0*M2Dglst2**2) - Mgl**4/M2Dglst2**3) + &
&     (5.d0*Mgl**2 + 3.d0*Mst1**2)/(2.d0*M2Dglst1**2) + &
&     Lgl**2*(-Mgl**2/(4.d0*M2Dglst2**2) + Mgl**4/M2Dglst2**3 + &
&       (Mgl**2*(3.d0*Mgl**2 + Mst1**2))/(4.d0*M2Dglst1**3)) + &
&     (M2Dglst2**(-1) - (2.d0*Mgl**2)/M2Dglst2**2 + (-Mgl**2 - Mst1**2)/M2Dglst1**2)*&
&      B0finglx + Lst1*(-1.d0/(2.d0*M2Dglst1) + &
&       (9.d0*Mgl**2)/(2.d0*M2Dglst1**2) - (4.d0*Mgl**4)/M2Dglst1**3 + &
&       ((-2.d0*Mgl**2)/M2Dglst1**2 + (2.d0*Mgl**4)/M2Dglst1**3)*B0finglx) &
&        + Lst2*(-1.d0/(2.d0*M2Dglst2) + (9.d0*Mgl**2)/(2.d0*M2Dglst2**2) - &
&       (4.d0*Mgl**4)/M2Dglst2**3 + ((-2.d0*Mgl**2)/M2Dglst2**2 + (2.d0*Mgl**4)/M2Dglst2**3)*&
&        B0finglx) + Lgl*((-5.d0*Mgl**2)/(2.d0*M2Dglst2**2) + &
&       (4.d0*Mgl**4)/M2Dglst2**3 + (3.d0*Mgl**4 + 5.d0*Mgl**2*Mst1**2)/(2.d0*M2Dglst1**3) + &
&       ((2.d0*Mgl**2)/M2Dglst2**2 - (2.d0*Mgl**4)/M2Dglst2**3 - (2.d0*Mgl**2*Mst1**2)/&
&          M2Dglst1**3)*B0finglx) + &
&     (1.d0/(2.d0*M2Dglst2**2) - (2.d0*Mgl**2)/M2Dglst2**3 + (-3.d0*Mgl**2 - Mst1**2)/&
&        (2.d0*M2Dglst1**3))*T0finglx + &
&     (-1.d0/(2.d0*M2Dglst1**2) + (2.d0*Mgl**2)/M2Dglst1**3)*T0finst1x + &
&     (-1.d0/(2.d0*M2Dglst2**2) + (2.d0*Mgl**2)/M2Dglst2**3)*T0finst2x)))
                       
      dzeta_mt_2_sqx_Xt1=(cf*tr*((-2.d0*Lx**2*Mx**2)/(M2Dglst1*M2Dglst2) + &
&   Lx*((6.d0*Lgl)/(M2Dglst1*M2Dglst2) - (2.d0*Lst1*Mst1**2)/&
&      (M2Dglst1*M2Dst1st2*Mgl**2) + Lst2*(-2.d0/(M2Dglst1*M2Dglst2) + &
&       (2.d0*Mst1**2)/(M2Dglst1*M2Dst1st2*Mgl**2)))*Mx**2 - &
&   (4.d0*Mgl**2*B0finglx)/(M2Dglst1*M2Dglst2) + &
&   (2.d0*Lst1*Mst1**2*(Mgl**2 + Mst1**2)*B0finglx)/&
&    (M2Dglst1**2*M2Dst1st2) + Lst2*((4.d0*Mgl**4)/(M2Dglst1*M2Dglst2**2) - &
&     (2.d0*Mgl**2*(Mgl**2 - 3.d0*Mst1**2))/(M2Dglst1**2*M2Dglst2) - &
&     (2.d0*Mst1**2*(Mgl**2 + Mst1**2))/(M2Dglst1**2*M2Dst1st2))*&
&    B0finglx + Lgl*((-4.d0*Mgl**4)/(M2Dglst1*M2Dglst2**2) - &
&     (-2.d0*Mgl**4 + 6.d0*Mgl**2*Mst1**2)/(M2Dglst1**2*M2Dglst2))*&
&    B0finglx + ((-4.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) - &
&     (-4.d0*Mgl**2 + 8.d0*Mst1**2)/(M2Dglst1**2*M2Dglst2))*T0finglx + &
&   (4.d0*Mst1**2*T0finst1x)/(M2Dglst1**2*M2Dst1st2) + &
&   ((4.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) + (4.d0*Mst1**2)/(M2Dglst1**2*M2Dglst2) - &
&     (4.d0*Mst1**2)/(M2Dglst1**2*M2Dst1st2))*T0finst2x + &
&   Mx**2*(-8.d0/(M2Dglst1*M2Dglst2) + Lgl**2*((-2.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) - &
&       (2.d0*Mgl**2)/(M2Dglst1**2*M2Dglst2)) + (2.d0*Lst1**2*Mst1**2)/&
&      (M2Dglst1**2*M2Dst1st2) + Lst2**2*((2.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) + &
&       (2.d0*Mst1**2)/(M2Dglst1**2*M2Dglst2) - (2.d0*Mst1**2)/&
&        (M2Dglst1**2*M2Dst1st2)) + (4.d0*B0finglx)/&
&      (M2Dglst1*M2Dglst2) + Lst1*((2.d0*Mst1**2*(3.d0*Mgl**2 + Mst1**2))/&
&        (M2Dglst1**2*M2Dst1st2*Mgl**2) - (2.d0*Mst1**2*(Mgl**2 + Mst1**2)*&
&         B0finglx)/(M2Dglst1**2*M2Dst1st2*Mgl**2)) + &
&     Lgl*((-8.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) - (2.d0*(Mgl**2 + 3.d0*Mst1**2))/&
&        (M2Dglst1**2*M2Dglst2) + ((4.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) - &
&         (2.d0*(Mgl**2 - 3.d0*Mst1**2))/(M2Dglst1**2*M2Dglst2))*B0finglx) &
&          + Lst2*((8.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) - &
&       (2.d0*(Mgl**2 - 5.d0*Mst1**2))/(M2Dglst1**2*M2Dglst2) - &
&       (2.d0*Mst1**2*(3.d0*Mgl**2 + Mst1**2))/(M2Dst1st2*(Mgl**3 - Mgl*Mst1**2)**2) + &
&       ((-4.d0*Mgl**2)/(M2Dglst1*M2Dglst2**2) - (-2.d0*Mgl**2 + 6.d0*Mst1**2)/&
&          (M2Dglst1**2*M2Dglst2) + (2.d0*Mst1**2*(Mgl**2 + Mst1**2))/&
&          (M2Dst1st2*(Mgl**3 - Mgl*Mst1**2)**2))*B0finglx) + &
&     (4.d0/(M2Dglst1*M2Dglst2**2) + 4.d0/(M2Dglst1**2*M2Dglst2))*T0finglx - &
&     (4.d0*T0finst1x)/(M2Dglst1**2*M2Dst1st2) + &
&     (-4.d0/(M2Dglst1*M2Dglst2**2) - 4.d0/(M2Dglst1**2*M2Dglst2) + &
&       4.d0/(M2Dglst1**2*M2Dst1st2))*T0finst2x)))
                                 
!       WRITE(Write_unit,66) " dzeta_mt_1_Xt0   = ", dzeta_mt_1_Xt0
!       WRITE(Write_unit,66) " dzeta_mt_1_Xt1   = ", dzeta_mt_1_Xt1
      
      dzeta_mt_2_sqx = (dzeta_mt_2_sqx_Xt0 + (Mgl*Xt)*dzeta_mt_2_sqx_Xt1)
      
! 66    FORMAT(A,E12.6)

   END FUNCTION dzeta_mt_2_sqx
   
   FUNCTION dzeta_mt_2_st(Mst1,Mst2,Mgl,Xt,muDec)

      IMPLICIT NONE

!!$  Passed variables

      REAL(kind=fp_kind), INTENT(IN) :: Mst1,Mst2,Mgl,Xt,muDec
      
!!$  function variable      
      REAL(kind=fp_kind):: dzeta_mt_2_st

!!$  Internal variables

      REAL(kind=fp_kind) :: Lst1, Lst2, Lgl
      REAL(kind=fp_kind) :: M2Dst1st2, M2Dglst1, M2Dglst2
      REAL(kind=fp_kind) :: B0finglst1, B0finglst2, B0finst1gl, B0finst2gl      
      REAL(kind=fp_kind) :: T0finglst2, T0finst1gl, T0finst1st2

      REAL(kind=fp_kind) ::dzeta_mt_2_st_Xt0_cacf, dzeta_mt_2_st_Xt0_cf2, dzeta_mt_2_st_Xt0_cftr
      REAL(kind=fp_kind) ::dzeta_mt_2_st_Xt1_cacf, dzeta_mt_2_st_Xt1_cf2, dzeta_mt_2_st_Xt1_cftr
      
      REAL(kind=fp_kind) ::dzeta_mt_2_st_Xt0, dzeta_mt_2_st_Xt1
      
      Lst1 = Log(muDec**2/Mst1**2)
      Lst2 = Log(muDec**2/Mst2**2)
      Lgl = Log(muDec**2/Mgl**2)

       
      M2Dst1st2 = Mst1**2-Mst2**2
      M2Dglst1  = Mgl**2-Mst1**2
      M2Dglst2  = Mgl**2-Mst2**2
      
      
      B0finglst1 = B0fin(Mgl**2, Mst1, 0.d0, muDec)
      B0finglst2 = B0fin(Mgl**2, Mst2, 0.d0, muDec)
      B0finst1gl = B0fin(Mst1**2, Mgl, 0.d0, muDec)
      B0finst2gl = B0fin(Mst2**2, Mgl, 0.d0, muDec)
      
      T0finglst2  = T0fin(Mgl, Mst2)
      T0finst1gl  = T0fin(Mst1, Mgl) 
      T0finst1st2 = T0fin(Mst1, Mst2)
      
!!$  Xt^0
!!$  ca*cf
      dzeta_mt_2_st_Xt0_cacf=((-7.d0*Mgl**2)/(2.d0*M2Dglst2) + Lst1**2*(-1.d0/4.d0 + Mgl**2/M2Dglst1 + &
&   (5.d0*Mgl**4)/(4.d0*M2Dglst1**2) - (2.d0*Mgl**6)/M2Dglst1**3) + &
& Lst2**2*(-1.d0/4.d0 + Mgl**2/M2Dglst2 + (5.d0*Mgl**4)/(4.d0*M2Dglst2**2) - &
&   (2.d0*Mgl**6)/M2Dglst2**3) + (229.d0*Mgl**2 - 481.d0*Mst1**2)/(72.d0*M2Dglst1) + &
& Lgl*(Mgl**2/M2Dglst2 - (11.d0*Mgl**4)/(2.d0*M2Dglst2**2) + &
&   (-37.d0*Mgl**4 + 14.d0*Mgl**2*Mst1**2 - 10.d0*Mst1**4)/(6.d0*M2Dglst1**2)) + &
& Lgl**2*(-Mgl**4/(4.d0*M2Dglst2**2) - (2.d0*Mgl**6)/M2Dglst2**3 - &
&   (-Mgl**4 + 2.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2) + &
&   (3.d0*Mgl**6 - 27.d0*Mgl**4*Mst1**2 + 20.d0*Mgl**2*Mst1**4 - 4.d0*Mst1**6)/(4.d0*M2Dglst1**3)) + &
& Lst2*(-3.d0 - (5.d0*Mgl**2)/(2.d0*M2Dglst2) + (11.d0*Mgl**4)/(2.d0*M2Dglst2**2) + &
&   Lgl*(-(Mgl**2/M2Dglst1) - Mgl**4/M2Dglst2**2 + (4.d0*Mgl**6)/M2Dglst2**3 - &
&     (2.d0*Mgl**4 - 3.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2))) + &
& Lst1*(-3.d0 - (5.d0*Mgl**2)/(2.d0*M2Dglst1) + (11.d0*Mgl**4)/(2.d0*M2Dglst1**2) + &
&   Lst2*(Mst1**2/M2Dglst1 - (Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2)) + &
&   Lgl*((Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2) + &
&     (7.d0*Mgl**4*Mst1**2 - 3.d0*Mgl**2*Mst1**4)/M2Dglst1**3)) + &
& (-M2Dglst1**(-1) + (3.d0*Mgl**2)/M2Dglst2**2 - (Mgl**2 - 3.d0*Mst1**2)/&
&    (M2Dglst1*M2Dglst2))*T0finglst2 + &
& ((3.d0*Mst1**2)/M2Dglst1**2 - (-Mgl**2 - Mst1**2)/(M2Dglst1*M2Dglst2))*T0finst1gl + &
& (M2Dglst1**(-1) - (Mgl**2 + Mst1**2)/(M2Dglst1*M2Dglst2))*T0finst1st2)

!!$  cf*cf
      dzeta_mt_2_st_Xt0_cf2=((3.d0*Mgl**4)/(8.d0*M2Dglst2**2) + Mgl**4/(4.d0*M2Dglst1*M2Dglst2) + &
& B0finst1gl*(1.d0 + (2.d0*Mgl**2)/M2Dglst1) + B0finst2gl*(1.d0 + (2.d0*Mgl**2)/M2Dglst2) + &
& (-218.d0*Mgl**4 + 442.d0*Mgl**2*Mst1**2 - 221.d0*Mst1**4)/(8.d0*M2Dglst1**2) + &
& Lst2**2*(-7.d0/8.d0 + (11.d0*Mgl**4)/(4.d0*M2Dglst2**2) - Mgl**6/(2.d0*M2Dglst2**3) + &
&   (3.d0*Mgl**8)/(8.d0*M2Dglst2**4) - (4.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dst1st2) - &
&   (-9.d0*Mgl**4 - 7.d0*Mgl**2*Mst1**2)/(4.d0*M2Dglst1*M2Dglst2)) + &
& Lgl*((3.d0*Mgl**6)/(4.d0*M2Dglst2**3) + B0finst1gl*((2.d0*Mgl**4)/M2Dglst1**2 + &
&     (4.d0*Mgl**4)/(M2Dglst1*M2Dglst2)) + &
&   B0finst2gl*((2.d0*Mgl**4)/M2Dglst2**2 + (4.d0*Mgl**4)/(M2Dglst1*M2Dglst2)) + &
&   (-7.d0*Mgl**6 + 8.d0*Mgl**4*Mst1**2)/(4.d0*M2Dglst1*M2Dglst2**2) + &
&   (-31.d0*Mgl**6 + 60.d0*Mgl**4*Mst1**2 - 26.d0*Mgl**2*Mst1**4)/(4.d0*M2Dglst1**3) - &
&   (89.d0*Mgl**6 - 116.d0*Mgl**4*Mst1**2 + 26.d0*Mgl**2*Mst1**4)/(4.d0*M2Dglst1**2*M2Dglst2)) + &
& Lgl**2*(-Mgl**6/(2.d0*M2Dglst2**3) + (3.d0*Mgl**8)/(8.d0*M2Dglst2**4) - &
&   (23.d0*Mgl**4 - 15.d0*Mgl**2*Mst1**2)/(4.d0*M2Dglst1*M2Dglst2) + &
&   (5.d0*Mgl**8 - 8.d0*Mgl**6*Mst1**2 + 4.d0*Mgl**4*Mst1**4)/(4.d0*M2Dglst1**2*M2Dglst2**2) + &
&   (-23.d0*Mgl**8 + 78.d0*Mgl**6*Mst1**2 - 82.d0*Mgl**4*Mst1**4 + 30.d0*Mgl**2*Mst1**6)/&
&    (8.d0*M2Dglst1**4)) + Lst1**2*((4.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dst1st2) + &
&   (30.d0*Mgl**6*Mst1**2 - 62.d0*Mgl**4*Mst1**4 + 42.d0*Mgl**2*Mst1**6 - 7.d0*Mst1**8)/&
&    (8.d0*M2Dglst1**4)) + Lst2*((-3.d0*Mgl**6)/(4.d0*M2Dglst2**3) - &
&   (16.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dst1st2) + (-15.d0*Mgl**2 + 16.d0*Mst1**2)/&
&    (4.d0*M2Dglst1) - (-83.d0*Mgl**4 + 19.d0*Mgl**2*Mst1**2)/(4.d0*M2Dglst1*M2Dglst2) + &
&   B0finst1gl*((-4.d0*Mgl**4)/(M2Dglst1*M2Dglst2) + (4.d0*Mgl**2*Mst1**2)/&
&      (M2Dglst1*M2Dst1st2)) + B0finst2gl*((-2.d0*Mgl**4)/M2Dglst2**2 - &
&     (4.d0*Mgl**4)/(M2Dglst1*M2Dglst2) + (4.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dst1st2)) + &
&   (7.d0*Mgl**6 - 8.d0*Mgl**4*Mst1**2)/(4.d0*M2Dglst1*M2Dglst2**2) + &
&   Lgl*(Mgl**6/M2Dglst2**3 - (3.d0*Mgl**8)/(4.d0*M2Dglst2**4) + &
&     (9.d0*Mgl**4 - 8.d0*Mgl**2*Mst1**2)/(4.d0*M2Dglst1**2) - (-7.d0*Mgl**4 + 11.d0*Mgl**2*Mst1**2)/&
&      (2.d0*M2Dglst1*M2Dglst2) + (-16.d0*Mgl**8 + 30.d0*Mgl**6*Mst1**2 - 15.d0*Mgl**4*Mst1**4)/&
&      (4.d0*M2Dglst1**2*M2Dglst2**2))) + &
& Lst1*((16.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dst1st2) - (4.d0*B0finst2gl*Mgl**2*Mst1**2)/&
&    (M2Dglst1*M2Dst1st2) + B0finst1gl*((-2.d0*Mgl**4)/M2Dglst1**2 - &
&     (4.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dst1st2)) - (2.d0*Mgl**4*Mst1**2 - Mgl**2*Mst1**4)/&
&    (4.d0*M2Dglst1**2*M2Dglst2) + (8.d0*Mgl**6 + 2.d0*Mgl**4*Mst1**2 - 29.d0*Mgl**2*Mst1**4 + &
&     16.d0*Mst1**6)/(4.d0*M2Dglst1**3) + Lst2*((2.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2) + &
&     (-10.d0*Mgl**2*Mst1**2 + 9.d0*Mst1**4)/(4.d0*M2Dglst1**2) + &
&     (2.d0*Mgl**6*Mst1**2 - Mgl**4*Mst1**4)/(4.d0*M2Dglst1**2*M2Dglst2**2)) + &
&   Lgl*((-2.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2) + &
&     (-2.d0*Mgl**6*Mst1**2 + Mgl**4*Mst1**4)/(4.d0*M2Dglst1**2*M2Dglst2**2) + &
&     (8.d0*Mgl**8 - 40.d0*Mgl**6*Mst1**2 + 51.d0*Mgl**4*Mst1**4 - 22.d0*Mgl**2*Mst1**6)/&
&      (4.d0*M2Dglst1**4))) + (2.d0/M2Dglst1 - (6.d0*Mgl**2)/M2Dglst2**2 + &
&   (8.d0*Mgl**2)/(M2Dglst1*M2Dst1st2) + (3.d0*Mgl**4)/M2Dglst2**3 - &
&   (13.d0*Mgl**2 + 11.d0*Mst1**2)/(2.d0*M2Dglst1*M2Dglst2))*T0finglst2 + &
& ((-8.d0*Mgl**2)/(M2Dglst1*M2Dst1st2) - (2.d0*(Mgl**2 + Mst1**2))/&
&    (M2Dglst1*M2Dglst2) + (5.d0*Mgl**4 - 10.d0*Mgl**2*Mst1**2 + 11.d0*Mst1**4)/&
&    (2.d0*M2Dglst1**3))*T0finst1gl + &
& (-2.d0/M2Dglst1 + (2.d0*(Mgl**2 + Mst1**2))/(M2Dglst1*M2Dglst2))*T0finst1st2)

!!$  cf*tr
      dzeta_mt_2_st_Xt0_cftr=(-(-61.d0*Mgl**2 + 3.d0*Mst1**2)/(2.d0*M2Dglst2) + (-44.d0*Mgl**4 + 4.d0*Mgl**2*Mst1**2)/&
&  M2Dglst2**2 + (119.d0*Mgl**4 - 583.d0*Mgl**2*Mst1**2 + 200.d0*Mst1**4)/(6.d0*M2Dglst1**2) + &
& B0finglst1*(-(M2Dglst1/M2Dglst2) + (2.d0*M2Dglst1*Mgl**2)/M2Dglst2**2 + &
&   (Mgl**2 + Mst1**2)/M2Dglst1) + ((5.d0*Mgl**2 + 3.d0*Mst1**2)*Mst2**2)/&
&  (2.d0*M2Dglst1**2) + B0finglst2*((2.d0*Mgl**2)/M2Dglst2 + &
&   (3.d0*Mgl**2*Mst1**2 - Mst1**4)/M2Dglst1**2 - ((Mgl**2 + Mst1**2)*Mst2**2)/&
&    M2Dglst1**2) + Lst2**2*(7.d0/2.d0 - (7.d0*Mgl**2 + Mst1**2)/(4.d0*M2Dglst2) + &
&   (-49.d0*Mgl**4 + 5.d0*Mgl**2*Mst1**2)/(4.d0*M2Dglst2**2) - (-11.d0*Mgl**6 + Mgl**4*Mst1**2)/&
&    M2Dglst2**3 + ((3.d0*Mgl**2 + Mst1**2)*Mst2**2)/(4.d0*M2Dglst1**2)) + &
& Lgl**2*(Mgl**2/(4.d0*M2Dglst2) + (55.d0*Mgl**4 - Mgl**2*Mst1**2)/(4.d0*M2Dglst2**2) - &
&   (11.d0*Mgl**6 - Mgl**4*Mst1**2)/M2Dglst2**3 + &
&   (Mgl**2*(12.d0*Mgl**4 - 57.d0*Mgl**2*Mst1**2 + Mst1**4))/(4.d0*M2Dglst1**3) + &
&   (Mgl**2*(3.d0*Mgl**2 + Mst1**2)*Mst2**2)/(4.d0*M2Dglst1**3)) + &
& Lst1**2*(-Mst1**2/(4.d0*M2Dglst2) + (Mgl**2*Mst1**2)/M2Dglst2**2 + &
&   (2.d0*Mgl**6 + 21.d0*Mgl**4*Mst1**2 + 35.d0*Mgl**2*Mst1**4 - 14.d0*Mst1**6)/(4.d0*M2Dglst1**3) - &
&   (Mst1**2*(3.d0*Mgl**2 + Mst1**2)*Mst2**2)/(4.d0*M2Dglst1**3)) + &
& Lst2*(31.d0/6.d0 + B0finglst1*((2.d0*M2Dglst1*Mgl**2)/M2Dglst2**2 - &
&     (2.d0*M2Dglst1*Mgl**4)/M2Dglst2**3) + &
&   B0finglst2*((2.d0*Mgl**2)/M2Dglst2 - (2.d0*Mgl**4)/M2Dglst2**2) - &
&   (-25.d0*Mgl**2 + Mst1**2)/(2.d0*M2Dglst2) + (-127.d0*Mgl**4 + 9.d0*Mgl**2*Mst1**2)/&
&    (2.d0*M2Dglst2**2) - (-44.d0*Mgl**6 + 4.d0*Mgl**4*Mst1**2)/M2Dglst2**3 - &
&   Mst2**2/(2.d0*M2Dglst1) + Lgl*((3.d0*Mgl**2)/(2.d0*M2Dglst2) - &
&     (3.d0*Mgl**4)/(2.d0*M2Dglst2**2) - (3.d0*Mgl**2*Mst2**2)/(2.d0*M2Dglst1**2))) + &
& Lgl*((5.d0*Mgl**2)/(2.d0*M2Dglst2) + (83.d0*Mgl**4 - 5.d0*Mgl**2*Mst1**2)/(2.d0*M2Dglst2**2) - &
&   (44.d0*Mgl**6 - 4.d0*Mgl**4*Mst1**2)/M2Dglst2**3 + &
&   (-93.d0*Mgl**4*Mst1**2 + 5.d0*Mgl**2*Mst1**4)/(2.d0*M2Dglst1**3) + &
&   B0finglst1*((2.d0*Mgl**2*Mst1**2)/M2Dglst1**2 + (-2.d0*Mgl**4 + 2.d0*Mgl**2*Mst1**2)/&
&      M2Dglst2**2 - (-2.d0*Mgl**6 + 2.d0*Mgl**4*Mst1**2)/M2Dglst2**3) + &
&   (Mgl**2*(3.d0*Mgl**2 + 5.d0*Mst1**2)*Mst2**2)/(2.d0*M2Dglst1**3) + &
&   B0finglst2*((-2.d0*Mgl**2)/M2Dglst2 + (2.d0*Mgl**4)/M2Dglst2**2 + &
&     (2.d0*Mgl**4*Mst1**2)/M2Dglst1**3 - (2.d0*Mgl**2*Mst1**2*Mst2**2)/M2Dglst1**3)) + &
& Lst1*(B0finglst1*((2.d0*Mgl**2)/M2Dglst1 - (2.d0*Mgl**4)/M2Dglst1**2) - &
&   Mst1**2/(2.d0*M2Dglst2) + Lgl*((-3.d0*Mgl**2*Mst1**2)/(2.d0*M2Dglst1**2) - &
&     (3.d0*Mgl**2*Mst1**2)/(2.d0*M2Dglst2**2)) + &
&   (-11.d0*Mgl**6 + 138.d0*Mgl**4*Mst1**2 + 168.d0*Mgl**2*Mst1**4 - 31.d0*Mst1**6)/&
&    (6.d0*M2Dglst1**3) - (Mst1**2*(7.d0*Mgl**2 + Mst1**2)*Mst2**2)/(2.d0*M2Dglst1**3) + &
&   Lst2*(Mst1**2/(2.d0*M2Dglst2) - (Mgl**2*Mst1**2)/(2.d0*M2Dglst2**2) - &
&     (Mst1**2*Mst2**2)/(2.d0*M2Dglst1**2)) + &
&   B0finglst2*((-2.d0*Mgl**4*Mst1**2)/M2Dglst1**3 + (2.d0*Mgl**2*Mst1**2*Mst2**2)/&
&      M2Dglst1**3)) + (-1.d0/(2.d0*M2Dglst2) + (-Mgl**4 + 5.d0*Mgl**2*Mst1**2)/&
&    (2.d0*M2Dglst1**3) - ((3.d0*Mgl**2 + Mst1**2)*Mst2**2)/(2.d0*M2Dglst1**3))*T0finglst2 + &
& (-1.d0/(2.d0*M2Dglst1) + (-5.d0*Mgl**2 + Mst1**2)/(2.d0*M2Dglst2**2) - &
&   (-2.d0*Mgl**4 + 2.d0*Mgl**2*Mst1**2)/M2Dglst2**3)*T0finst1gl + &
& (M2Dglst1/(2.d0*M2Dglst2**2) + 1.d0/(2.d0*M2Dglst2) - (2.d0*M2Dglst1*Mgl**2)/M2Dglst2**3 + &
&   (-2.d0*Mgl**4 - 3.d0*Mgl**2*Mst1**2 + Mst1**4)/(2.d0*M2Dglst1**3) + &
&   ((3.d0*Mgl**2 + Mst1**2)*Mst2**2)/(2.d0*M2Dglst1**3))*T0finst1st2)

      
!!$  Xt^1
!!$  ca*cf
      dzeta_mt_2_st_Xt1_cacf=((14.d0*Lgl*Mgl**2)/(M2Dglst1*M2Dglst2) - (2.d0*Lst1**2*Mst1**2*(Mgl**2 - 3.d0*Mst1**2))/&
&  (M2Dglst1**2*M2Dst1st2) + Lgl**2*((4.d0*Mgl**4)/(M2Dglst1*M2Dglst2**2) + &
&   (4.d0*Mgl**2*Mst1**2)/(M2Dglst1**2*M2Dglst2)) + &
& Lst1*((-14.d0*Mst1**2)/(M2Dglst1*M2Dst1st2) - (2.d0*Lgl*Mst1**2*(Mgl**2 + 3.d0*Mst1**2))/&
&    (M2Dglst1**2*M2Dst1st2)) + Lst2**2*((4.d0*Mgl**4)/(M2Dglst1*M2Dglst2**2) - &
&   (6.d0*Mgl**4 - 10.d0*Mgl**2*Mst1**2)/(M2Dglst1**2*M2Dglst2) - &
&   (-2.d0*Mgl**2*Mst1**2 + 6.d0*Mst1**4)/(M2Dglst1**2*M2Dst1st2)) + &
& Lst2*((-14.d0*Mgl**2)/(M2Dglst1*M2Dglst2) + (14.d0*Mst1**2)/(M2Dglst1*M2Dst1st2) + &
&   Lgl*((-8.d0*Mgl**4)/(M2Dglst1*M2Dglst2**2) + (2.d0*Mst1**2*(Mgl**2 + 3.d0*Mst1**2))/&
&      (M2Dglst1**2*M2Dst1st2) - (-6.d0*Mgl**4 + 14.d0*Mgl**2*Mst1**2)/&
&      (M2Dglst1**2*M2Dglst2))) - (2.d0*(2.d0*Mgl**2 - 3.d0*Mst1**2 + Mst2**2)*T0finglst2)/&
&  (M2Dglst1*M2Dglst2*M2Dst1st2) + &
& (2.d0*(2.d0*Mgl**2 + Mst1**2 - 3.d0*Mst2**2)*T0finst1gl)/(M2Dglst1*M2Dglst2*M2Dst1st2) - &
& (2.d0*T0finst1st2)/(M2Dglst1*M2Dglst2))
      
!!$  cf*cf
      dzeta_mt_2_st_Xt1_cf2=((-4.d0*B0finst1gl)/M2Dst1st2 + (4.d0*B0finst2gl)/M2Dst1st2 - &
& (Lst1**2*Mst1**4*(4.d0*Mgl**2 - 3.d0*Mst1**2))/(M2Dglst1**3*M2Dst1st2) + &
& Lgl*((-4.d0*B0finst1gl*Mgl**2)/(M2Dglst1*M2Dst1st2) - &
&   Mgl**4/(M2Dglst1*M2Dglst2**2) + B0finst2gl*((-4.d0*Mgl**2)/(M2Dglst1*M2Dglst2) + &
&     (4.d0*Mgl**2)/(M2Dglst1*M2Dst1st2)) - (-12.d0*Mgl**4 + 13.d0*Mgl**2*Mst1**2)/&
&    (M2Dglst1**2*M2Dglst2)) + Lgl**2*((-2.d0*Mgl**4)/(M2Dglst1*M2Dglst2**2) - &
&   Mgl**6/(M2Dglst1*M2Dglst2**3) + (Mgl**2*(Mgl**4 - 6.d0*Mgl**2*Mst1**2 + 4.d0*Mst1**4))/&
&    (M2Dglst1**3*M2Dglst2)) + Lst2**2*(-(Mgl**6/(M2Dglst1*M2Dglst2**3)) + &
&   (-2.d0*Mgl**6 + Mgl**4*Mst1**2)/(M2Dglst1**2*M2Dglst2**2) - &
&   (-3.d0*Mgl**6 + 9.d0*Mgl**4*Mst1**2 - 5.d0*Mgl**2*Mst1**4)/(M2Dglst1**3*M2Dglst2) - &
&   (-4.d0*Mgl**2*Mst1**4 + 3.d0*Mst1**6)/(M2Dglst1**3*M2Dst1st2)) + &
& Lst2*(Mgl**4/(M2Dglst1*M2Dglst2**2) + &
&   B0finst2gl*((4.d0*Mgl**2)/(M2Dglst1*M2Dglst2) - &
&     (4.d0*Mgl**2)/(M2Dglst1*M2Dst1st2)) - (2.d0*Mgl**2*(6.d0*Mgl**2 - 7.d0*Mst1**2))/&
&    (M2Dglst1**2*M2Dglst2) - (-4.d0*Mgl**4 - 3.d0*Mgl**2*Mst1**2 + 9.d0*Mst1**4)/&
&    (M2Dglst1**2*M2Dst1st2) + Lgl*((2.d0*Mgl**6)/(M2Dglst1*M2Dglst2**3) + &
&     (4.d0*Mgl**6 - 3.d0*Mgl**4*Mst1**2)/(M2Dglst1**2*M2Dglst2**2) - &
&     (-4.d0*Mgl**6 + 14.d0*Mgl**4*Mst1**2 - 8.d0*Mgl**2*Mst1**4)/(M2Dglst1**3*M2Dst1st2) - &
&     (4.d0*Mgl**6 - 15.d0*Mgl**4*Mst1**2 + 9.d0*Mgl**2*Mst1**4)/(M2Dglst1**3*M2Dglst2))) + &
& Lst1*((4.d0*B0finst1gl*Mgl**2)/(M2Dglst1*M2Dst1st2) + &
&   Lst2*(-((Mgl**2*Mst1**2)/(M2Dglst1**2*M2Dglst2)) + &
&     (Mgl**4*Mst1**2)/(M2Dglst1**2*M2Dglst2**2)) + &
&   Lgl*((Mgl**2*Mst1**2)/(M2Dglst1**2*M2Dglst2) - (Mgl**4*Mst1**2)/&
&      (M2Dglst1**2*M2Dglst2**2) - (4.d0*Mgl**6 - 14.d0*Mgl**4*Mst1**2 + 8.d0*Mgl**2*Mst1**4)/&
&      (M2Dglst1**3*M2Dst1st2)) + (-4.d0*Mgl**6 - 9.d0*Mst1**4*Mst2**2 + &
&     4.d0*Mgl**2*Mst1**2*(2.d0*Mst1**2 + Mst2**2) + Mgl**4*(-3.d0*Mst1**2 + 4.d0*Mst2**2))/&
&    (M2Dglst1**2*M2Dglst2*M2Dst1st2)) - (4.d0*T0finglst2)/(M2Dglst1*M2Dglst2) - &
& (4.d0*T0finst1gl)/(M2Dglst1*M2Dglst2) + (4.d0*T0finst1st2)/(M2Dglst1*M2Dglst2))
      
!!$  cf*tr
      dzeta_mt_2_st_Xt1_cftr=(8.d0/M2Dglst1 - (4.d0*B0finglst2)/M2Dglst1 - (4.d0*B0finglst1)/M2Dglst2 - &
& (-88.d0*Mgl**2 + 8.d0*Mst1**2)/(M2Dglst1*M2Dglst2) + &
& Lgl**2*((2.d0*Mgl**2)/M2Dglst1**2 - (24.d0*Mgl**4 - 44.d0*Mgl**2*Mst1**2)/&
&    (M2Dglst1**2*M2Dglst2) + (22.d0*Mgl**4 - 2.d0*Mgl**2*Mst1**2)/&
&    (M2Dglst1*M2Dglst2**2)) + Lst1**2*((-2.d0*Mst1**2)/M2Dglst1**2 - &
&   (2.d0*Mst1**2)/(M2Dglst1*M2Dglst2) - (22.d0*Mgl**2*Mst1**4 - 2.d0*Mst1**6)/&
&    (M2Dglst1**2*M2Dst1st2*Mgl**2)) + &
& Lst2**2*((4.d0*Mgl**2 - 2.d0*Mst1**2)/(Mgl**4 - Mgl**2*Mst1**2) + &
&   (-22.d0*Mgl**4 + 2.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2**2) + &
&   (2.d0*(9.d0*Mgl**4 - 20.d0*Mgl**2*Mst1**2 + Mst1**4))/(M2Dglst1**2*M2Dglst2) - &
&   (-22.d0*Mgl**2*Mst1**4 + 2.d0*Mst1**6)/(M2Dglst1**2*M2Dst1st2*Mgl**2)) + &
& Lst2*(2.d0/Mgl**2 + Lgl*(-6.d0/M2Dglst1 + (6.d0*Mgl**2)/(M2Dglst1*M2Dglst2)) + &
&   (-88.d0*Mgl**4 + 8.d0*Mgl**2*Mst1**2)/(M2Dglst1*M2Dglst2**2) + &
&   (2.d0*(43.d0*Mgl**4 - 88.d0*Mgl**2*Mst1**2 + 5.d0*Mst1**4))/(M2Dglst1**2*M2Dglst2) - &
&   (-84.d0*Mgl**2*Mst1**4 + 4.d0*Mst1**6)/(M2Dglst1**2*M2Dst1st2*Mgl**2) + &
&   B0finglst2*(-2.d0/Mgl**2 + (4.d0*Mgl**2)/(M2Dglst1*M2Dglst2) - &
&     (2.d0*Mst1**2*(Mgl**2 + Mst1**2))/(M2Dglst1*M2Dst1st2*Mgl**2)) + &
&   B0finglst1*((4.d0*Mgl**2)/M2Dglst2**2 - (2.d0*(Mgl**2 - 3.d0*Mst1**2))/&
&      (M2Dglst1*M2Dglst2) - (2.d0*Mst1**2*(Mgl**2 + Mst1**2))/&
&      (M2Dglst1*M2Dst1st2*Mgl**2))) + &
& Lgl*((2.d0*(Mgl**2 + 3.d0*Mst1**2))/M2Dglst1**2 + (88.d0*Mgl**4 - 8.d0*Mgl**2*Mst1**2)/&
&    (M2Dglst1*M2Dglst2**2) - (42.d0*Mgl**4 - 128.d0*Mgl**2*Mst1**2 + 6.d0*Mst1**4)/&
&    (M2Dglst1**2*M2Dglst2) + B0finglst2*((-4.d0*Mgl**2)/(M2Dglst1*M2Dglst2) + &
&     (2.d0*(Mgl**2 - 3.d0*Mst1**2))/M2Dglst1**2) + &
&   B0finglst1*((-4.d0*Mgl**2)/M2Dglst2**2 - (-2.d0*Mgl**2 + 6.d0*Mst1**2)/&
&      (M2Dglst1*M2Dglst2))) + Lst1*((6.d0*Lgl*Mst1**2)/(M2Dglst1*M2Dglst2) + &
&   (2.d0*B0finglst1*Mst1**2*(Mgl**2 + Mst1**2))/(M2Dglst1*M2Dst1st2*Mgl**2) - &
&   (2.d0*(3.d0*Mgl**2*Mst1**2 + Mst1**4))/(M2Dglst1**2*Mgl**2) - &
&   (84.d0*Mgl**2*Mst1**4 - 4.d0*Mst1**6)/(M2Dglst1**2*M2Dst1st2*Mgl**2) + &
&   B0finglst2*((2.d0*Mst1**2*(Mgl**2 + Mst1**2))/(M2Dglst1**2*Mgl**2) + &
&     (2.d0*Mst1**2*(Mgl**2 + Mst1**2))/(M2Dglst1*M2Dst1st2*Mgl**2)) + &
&   Lst2*((-2.d0*Mst1**2)/(M2Dglst1*M2Dglst2) + &
&     (2.d0*Mst1**2)/(Mgl**4 - Mgl**2*Mst1**2))) + &
& (-4.d0/M2Dglst1**2 + 4.d0/(M2Dglst1*M2Dglst2))*T0finglst2 + &
& (-4.d0/M2Dglst2**2 + 4.d0/(M2Dglst1*M2Dglst2))*T0finst1gl + &
& (4.d0/M2Dglst1**2 + 4.d0/M2Dglst2**2)*T0finst1st2)

      
      dzeta_mt_2_st_Xt0 =( ca*cf*dzeta_mt_2_st_Xt0_cacf&
                        &+cf*cf*dzeta_mt_2_st_Xt0_cf2 &
                        &+cf*tr*dzeta_mt_2_st_Xt0_cftr)

      dzeta_mt_2_st_Xt1 =( ca*cf*dzeta_mt_2_st_Xt1_cacf&
                        &+cf*cf*dzeta_mt_2_st_Xt1_cf2 &
                        &+cf*tr*dzeta_mt_2_st_Xt1_cftr)                        

!       WRITE(Write_unit,66) " dzeta_mt_2_st_Xt0   = ", dzeta_mt_2_st_Xt0
!       WRITE(Write_unit,66) " dzeta_mt_2_st_Xt1   = ", dzeta_mt_2_st_Xt1 
 
      dzeta_mt_2_st = (dzeta_mt_2_st_Xt0 + (Mgl*Xt)*dzeta_mt_2_st_Xt1)

      
!       WRITE(Write_unit,66) " dzeta_mt_2_st   = ", dzeta_mt_2_st 
      
! 66    FORMAT(A,E12.6)      

   END FUNCTION dzeta_mt_2_st   

END MODULE mod_dzeta_mt
