MODULE mod_int_imp

   USE mod_num_parms

      IMPLICIT NONE

   
CONTAINS

   FUNCTION B0fin(p2,m1,m2,muRen)

   
      IMPLICIT NONE

!!$  Passed variables

      REAL(kind=fp_kind), INTENT(IN) :: p2,m1,m2,muRen
      
!!$  function variable      
      REAL(kind=fp_kind):: B0fin

!!$  Internal variables

      REAL(kind=rl_kind), PARAMETER :: Tolerance = 1.d0/10**8
      LOGICAL :: CaseNotFound = .TRUE.
      
      B0fin = 0.d0
      
      IF (ABS(m1) < Tolerance .AND. ABS(p2) > Tolerance**2 .AND. ABS(m2) > Tolerance ) THEN
          B0fin = (2.d0 + Log(muRen**2/Abs(p2 - m2**2)) + m2**2/p2*Log(Abs(p2 - m2**2)/m2**2))
          CaseNotFound = .FALSE.
      ENDIF
      
      IF (ABS(m2) < Tolerance .AND. ABS(p2) > Tolerance**2 .AND. ABS(m1) > Tolerance ) THEN
          B0fin = (2.d0 + Log(muRen**2/Abs(p2 - m1**2)) + m1**2/p2*Log(Abs(p2 - m1**2)/m1**2))
          CaseNotFound = .FALSE.
      ENDIF
      
!       IF (ABS(p2) < Tolerance**2  ) THEN
!                 IF (ABS(m1-m2) > Tolerance  ) THEN
!                     B0fin = ((1& 
!                              &+(-(m1**2*Log(m1**2))+ m2**2*Log(m2**2))/(m1**2 - m2**2) &
!                              &+ Log(muRen**2)))
!                     CaseNotFound = .FALSE.
!                 ELSE
!                     B0fin = Log(4.d0*muRen**2/(m1+m2)**2)
!                     CaseNotFound = .FALSE.
!                 ENDIF
!       ENDIF
      
      IF ( CaseNotFound .EQV. .TRUE. ) &
               WRITE(Write_unit,*) "B0fin encountered unknown argument case!"
               RETURN

   END FUNCTION B0fin
   
   FUNCTION T0fin(m1,m2)


   
      IMPLICIT NONE

!!$  Passed variables

      REAL(kind=fp_kind), INTENT(IN) :: m1,m2
      
!!$  function variable      
      REAL(kind=fp_kind):: T0fin

!!$  Internal variables

      REAL(kind=rl_kind), PARAMETER :: Tolerance = 1.d0/10**8
      LOGICAL :: CaseNotFound = .TRUE.
      
      REAL(kind=rl_kind), EXTERNAL ::  Li2
      
      REAL(kind=rl_kind) :: y  
      
      T0fin = 0.d0
      

! TfinZEROaux[M2_,M3_] := + 2 M2^2 Log[M2/M3]^2 +
! M3^2/2*(2 (1-y) Log[1-y] Log[y] + 2 (1-y) PolyLog[2,y] - (1-y) Pi^2/3)/.{y->M2^2/M3^2};
! 
! TfinZEROshort[M2_?NumberQ, M3_?NumberQ] :=
!     Which[M2 < M3, TfinZEROaux[M2, M3],
!           M3 < M2, TfinZEROaux[M3, M2],
!           M2 == M3,0];
      
      IF (ABS(m1) < ABS(m2)) THEN
      
          y=m1**2/m2**2
          
          T0fin = (2.d0*m1**2*Log(m1/m2)**2 &
                  &+m2**2/2.d0*(2.d0*(1.d0-y)*Log(1.d0-y)*Log(y) &
                  &+ 2.d0*(1.d0-y)*Li2(y) - (1.d0-y)*Pi**2/3.d0))
                  
          CaseNotFound = .FALSE.
          
      ENDIF
      
      IF (ABS(m1) > ABS(m2)) THEN
      
          y=m2**2/m1**2
          
          T0fin = (2.d0*m2**2*Log(m2/m1)**2 &
                  &+m1**2/2.d0*(2.d0*(1.d0-y)*Log(1.d0-y)*Log(y) &
                  &+ 2.d0*(1.d0-y)*Li2(y) - (1.d0-y)*Pi**2/3.d0))
                  
          CaseNotFound = .FALSE.
          
      ENDIF
      
      IF (ABS(m1) .EQ. ABS(m2)) THEN
              
          T0fin = 0.d0
                  
          CaseNotFound = .FALSE.
          
      ENDIF
      
      IF ( CaseNotFound .EQV. .TRUE. ) &
               WRITE(Write_unit,*) "T0fin encountered unknown argument case!"
               RETURN

   END FUNCTION T0fin

END MODULE mod_int_imp